#include <stdio.h>
#include "kv_map.h"


#define N 15000

int main(void)
{
	kv_map_t * map = & KV_MAP_INIT(int, true, false, false);

	for (int i = 0; i < N; i++) {
		char key[20];
		sprintf(key, "a%d", i);
		int * v = kv_map_get(map, key);
		if (v)
			*v = i;
	}

	printf("nodes: %zu, load_factor: %lf, collisions: %zu, memory usage: %zu\n",
		   kv_map_count(map),
		   (1.0 * kv_map_count(map)) / kv_map_bucket_count(map),
		   kv_map_collision_count(map),
		   kv_map_mem_size(map));

	kv_map_iter_t * iter = & KV_MAP_ITER_INIT(map);

	int * v;
	while ((v = kv_map_next_value(iter)))
		*v += 17;

	for (int i = 4; i < N - 4; i++) {
		char key[20];
		sprintf(key, "a%d", i);
		kv_map_remove(map, key);
	}

	printf("nodes: %zu, load_factor: %lf, collisions: %zu, memory usage: %zu\n",
		   kv_map_count(map),
		   (1.0 * kv_map_count(map)) / kv_map_bucket_count(map),
		   kv_map_collision_count(map),
		   kv_map_mem_size(map));

	while ((v = kv_map_next_value(iter)))
		printf("%d ", *v);
	putchar('\n');

	kv_map_clear(map);

	printf("after clear %zu key-value pairs are left\n", kv_map_count(map));
}
