#include <stdio.h>
#include "kv_map.h"


int init(const char * key, FILE ** v)
{
	return (*v = fopen(key, "r")) == NULL;     // return 0 on success!
}

void del(const char * key, FILE ** v)
{
	printf("closing file '%s'\n", key);
	fclose(*v);
}

int main(void)
{
	kv_map_t * map = & KV_MAP_INIT(FILE *, true, init, del);

	kv_map_get(map, "../kv_map.c");
	kv_map_get(map, "../kv_map.h");
	kv_map_get(map, "../kv_map.txt");
	kv_map_get(map, "zzz");
	kv_map_get(map, "test3.c");

	kv_map_iter_t * iter = & KV_MAP_ITER_INIT(map);

	FILE ** v;
	while ((v = kv_map_next_value(iter))) {
		char buf[128];
		if (fgets(buf, sizeof buf, *v))
			printf("%s", buf);
	}

	kv_map_clear(map);
}
