/*
 * This test program requires some data, a file with lots of words
 * like what you can download here:
 *
 * https://raw.githubusercontent.com/dwyl/english-words/master/words.txt
 *
 * It's just meant to test how much memory is used with larger numbers
 * of nodes and how well they get distributed over the buckets.
 */

#include <stdio.h>
#include <string.h>
#include "kv_map.h"

int main(void)
{
bk	kv_map_t *map = & KV_MAP_INIT(int, false, NULL, NULL);

	FILE * fp = fopen("words.txt", "r");
	if (! fp) {
		fprintf(stderr, "Couldn't open a file named 'words.txt'\n");
		return 0;
	}

	char buf[128];
	while (fgets(buf, sizeof buf, fp)) {
		size_t len = strlen(buf);
		if (buf[len - 1] == '\n')
			buf[len - 1] = '\0';
		kv_map_add(map, buf);
	}

	printf("nodes: %zu, buckets: %zu, empty buckets: %zu, collisions: %zu, "
		   "memory usage: %zu\n",
		   kv_map_count(map), kv_map_bucket_count(map),
		   kv_map_empty_bucket_count(map), kv_map_collision_count(map),
		   kv_map_mem_size(map));

	kv_map_clear(map);
}
